--[[
An entity to track form status and switch the costume back to the standard
form one when the player switches back. Right now this doesn't support use
of treasure based costumes. I'll see about fixing that soon with some kind
of change costume override. Also you need to put this on every map in the mod
where you are using the custom form. I should remedy this soon too.

Script by Titch
Based on Script by Edwards]]--
dofile("scripts/entities/entityinclude.lua")
done_teleport = false
tp = 0

function init(me)
	n = getNaija()
	entity_setPosition(me, entity_x(n), entity_y(n))
	setupEntity(me)
	entity_alpha(me, 0)
end

function postInit(me)
	--Failsafe in case multiple copies of the entity exist
	local e = getFirstEntity()
	while e ~= 0 do
		if e ~= me and entity_isName(e, entity_getName(me)) then	
			entity_msg(e, "suicide")
		end
		e = getNextEntity()
	end
end

function update(me, dt)
	--Keep the entity on top of Naija, as an easy way to make sure it never goes out of culling distance.
    local f = getForm()
	local x,y = entity_getPosition(n)
	entity_setPosition(me, x, y)
    if f == 0 and getCostume() ~= "" then
        resetForm()
    end
    if f== 9 and avatar_isBursting()==true and done_teleport==false then
        teleport(getMouseWorldPos())
        done_teleport = true
    end
    if avatar_isBursting()==false then
        done_teleport = false
    end
end

--Failsafe in case extra copies were created
function msg(me, msg)
	if msg == "suicide" then
		entity_delete(me)
	end
end

function resetForm()
    setCostume ("")
end

function teleport (x,y)
    local ox = entity_getPositionX(n)
    local oy = entity_getPositionY(n)
    entity_setPositionX (n,x) 
    entity_setPositionY (n,y) 
    if entity_isNearObstruction (n, 1, OBSCHECK_RANGE) then
        entity_setPositionX (n,ox) 
        entity_setPositionY (n,oy) 
    else
        entity_sound(n,"memory-flash",1000,0)
        spawnParticleEffect("shockwave",ox,oy)
        done_teleport=true
    end
    
end